<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xalan="http://xml.apache.org/xalan"
                   exclude-result-prefixes="xalan" xmlns:nk="http://1060.org">
	<xsl:import href="/nkse/style/xsl/xmlverbatim.xsl"/>
    <xsl:output method="xml"/>
    <xsl:param name="resourceSpaceHash" nk:class="java.lang.String"/>
    <xsl:param name="parentHash" nk:class="java.lang.String"/>
    <xsl:param name="hash" nk:class="java.lang.String"/>
	
	<xsl:param name="deployed"><modules/></xsl:param>
	<xsl:param name="hrd"></xsl:param>
	<xsl:param name="javadoc"></xsl:param>
	<xsl:param name="proto"></xsl:param>
	<xsl:param name="delegateSpace"></xsl:param>
	<xsl:param name="statePlugin"></xsl:param>
	<xsl:param name="refs"></xsl:param>
	<xsl:param name="pageId" nk:class="java.lang.String"></xsl:param>
	
	<xsl:variable name="base">/tools/explore/</xsl:variable>
	<xsl:variable name="cr">/tools/cr</xsl:variable>
	 
	<xsl:template match="/meta">

		<div class="{$pageId}" tabtitle="{name}" xmlns:xrl='http://netkernel.org/xrl'>

			<xrl:include identifier="active:aeMenu" argument-hash="{$hash}"/>
					
			<xsl:choose>
				<xsl:when test="$refs">
					<xsl:attribute name="tabicon">ui-icon ui-icon-extlink</xsl:attribute>
				</xsl:when>
				<xsl:when test="contains(class,'IRepresentationMeta')">
					<xsl:attribute name="tabicon">ui-icon-ae ui-icon-ae-rep</xsl:attribute>
				</xsl:when>
				<xsl:when test="contains(class,'IPrototypeMeta')">
					<xsl:attribute name="tabicon">ui-icon-ae ui-icon-ae-proto</xsl:attribute>
				</xsl:when>
				<xsl:when test="contains(class,'IEndpointMeta')">
					<xsl:attribute name="tabicon">ui-icon-ae ui-icon-ae-ep</xsl:attribute>
				</xsl:when>
				<xsl:when test="contains(class,'ISpaceMeta')">
					<xsl:attribute name="tabicon">ui-icon-ae ui-icon-ae-space</xsl:attribute>
				</xsl:when>
				<xsl:when test="contains(class,'IModuleMeta')">
					<xsl:attribute name="tabicon">ui-icon-ae ui-icon-ae-module</xsl:attribute>
				</xsl:when>
				<xsl:when test="contains(class,'IPhysicalEndpointMeta')">
					<xsl:attribute name="tabicon">ui-icon-ae ui-icon-ae-physical</xsl:attribute>
				</xsl:when>
			</xsl:choose>
		
		
			<script type="text/javascript"><xsl:comment>
				$(document).ready(function()
				{	initLinksRaw( ".<xsl:value-of select="$pageId"/> .el-module", "gMenuModule");
					initLinksRaw( ".<xsl:value-of select="$pageId"/> .el-space", "gMenuSpace");
					initLinksRaw( ".<xsl:value-of select="$pageId"/> .el-physical", "gMenuPhysical");
					initLinksRaw( ".<xsl:value-of select="$pageId"/> .el-ep", "gMenuEp");
					initLinksRaw( ".<xsl:value-of select="$pageId"/> .el-proto", "gMenuProto");
					initLinksRaw( ".<xsl:value-of select="$pageId"/> .el-rep", "gMenuRep");
				});
			</xsl:comment></script>
			

			<table style="width: 100%;">
			
				<tr>
					<td style="width: 0%;"></td>
					<td style="width: 100%"></td>
				</tr>
			
			<xsl:choose>
				<xsl:when test="contains(class,'IEndpointMeta')">
					<xsl:call-template name="endpoint"/>
				</xsl:when>
				<xsl:when test="contains(class,'IPrototypeMeta')">
					<xsl:call-template name="prototype"/>
				</xsl:when>
				<xsl:when test="contains(class,'IRepresentationMeta')">
					<xsl:call-template name="representation"/>
				</xsl:when>
				<xsl:when test="contains(class,'ISpaceMeta')">
					<xsl:call-template name="space"/>
				</xsl:when>
				<xsl:when test="contains(class,'IModuleMeta')">
					<xsl:call-template name="module"/>
				</xsl:when>
				<xsl:when test="contains(class,'IPhysicalEndpointMeta')">
					<xsl:call-template name="physical"/>
				</xsl:when>
			</xsl:choose>
			
			</table>	
				
		</div>
	</xsl:template>	
	
	<xsl:template name="module">
		<tr><td class="label">type:</td><td>module</td></tr>
		<tr><td class="label">identifier:</td><td><xsl:value-of select="identifier"/></td></tr>
		<tr><td class="label">version:</td><td><xsl:value-of select="version"/></td></tr>
		<tr><td class="label">source:</td><td><xsl:value-of select="source"/></td></tr>
		
		<xsl:choose>
			<xsl:when test="not($refs)">
		
				<tr><td class="label">spaces:</td><td>
					<script type="text/javascript"><xsl:comment>
					$(document).ready(function()
					{	
						initDataTable('<xsl:value-of select="$pageId"/>tab',
						{	"aoColumnDefs": [
							 { "bVisible": false, "aTargets": [ 0 ] },
							 { "iDataSort": 0, "aTargets": [ 1 ] } ],
							"bLengthChange": false,
							"bFilter": false,
							"bInfo": false,
							"bPaginate": false
						},
						function(t)
						{	t.width("100%");
						} );
						
					});
					</xsl:comment></script>
					<table  id="{$pageId}tab" cellpadding="0" cellspacing="0" border="0" style="width:100%;">
					<thead><tr><th>Order</th><th>Space</th><th>Identifier</th><th>Public</th><th>Errors</th></tr></thead>
					<xsl:for-each select="spaces/space">
						<xsl:call-template name="module-space"/>
					</xsl:for-each>
					</table>
				</td></tr>
				<xsl:call-template name="state"/>
			</xsl:when>
			<xsl:otherwise>
				<tr><td class="label">references:</td><td>
					<xsl:call-template name="space-references"/>
				</td></tr>			
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<xsl:template name="module-space">
		<xsl:param name="s"/>
		<xsl:param name="depth">0</xsl:param>
		<tr entity="{hash}" class="el el-space">
			<xsl:if test="public='true'">
				<xsl:attribute name="style">font-weight: bold;</xsl:attribute>
			</xsl:if>
			<xsl:if test="problem">
				<xsl:attribute name="class">error el-space</xsl:attribute>
			</xsl:if>
			<td>
				<xsl:value-of select="count(preceding::space)"/>
			</td>
			
			<td style="padding-left: {$depth}em;">
				<span class="ui-icon-ae ui-icon-ae-space"><xsl:text> </xsl:text></span>
				<span><xsl:choose>
					<xsl:when test="string-length(name)"><xsl:value-of select="name"/></xsl:when>
					<xsl:otherwise><xsl:value-of select="id"/></xsl:otherwise>
				</xsl:choose></span>
				</td>
			<td><xsl:value-of select="id"/></td>
			<td>
				<span style="display: none;"><xsl:value-of select="public"/></span>
				<input type="checkbox" disabled="">
					<xsl:if test="public='true'"><xsl:attribute name="checked"/></xsl:if>
				</input>
			</td>
			<td>
				<span style="display: none;"><xsl:value-of select="problem"/><xsl:text> </xsl:text></span>
				<input type="checkbox" disabled="">
					<xsl:if test="problem"><xsl:attribute name="checked"/></xsl:if>
				</input>
			</td>
			
		</tr>
		<xsl:for-each select="spaces/space">
			<xsl:call-template name="module-space">
				<xsl:with-param name="depth"><xsl:value-of select="$depth + 1"/></xsl:with-param>
			</xsl:call-template>
		</xsl:for-each>
	</xsl:template>
	
	<xsl:template name="space">
		<tr><td class="label">type:</td>
			<td><xsl:choose><xsl:when test="public='true'">public</xsl:when><xsl:otherwise>private</xsl:otherwise></xsl:choose> space</td>
		</tr>
		<!--
		<tr><td class="label">module:</td><td>
			<a class="el el-module" entity="{$parentHash}"><xsl:value-of select="$deployed/modules/module[hash=$parentHash]/name"/></a>
		</td></tr>
		-->
		<xsl:if test="public='true'">
			<tr><td class="label">identifier:</td><td>
				<xsl:choose>
					<xsl:when test="string-length(identifier)">
						<xsl:value-of select="identifier"/>
					</xsl:when>
					<xsl:otherwise>[none] (private)
					</xsl:otherwise>
				</xsl:choose>
			</td></tr>
			<tr><td class="label">version:</td><td>
				<xsl:choose>
					<xsl:when test="string-length(version)">
						<xsl:value-of select="version"/>
					</xsl:when>
					<xsl:otherwise>[none] (private)
					</xsl:otherwise>
				</xsl:choose>
			</td></tr>
		</xsl:if>
		
		<xsl:choose>
			<xsl:when test="$refs">
				<tr><td class="label">references:</td><td>
					<xsl:call-template name="space-references"/>
				</td></tr>
			</xsl:when>
			<xsl:otherwise>
				<tr><td class="label">endpoints:</td><td>
					<script type="text/javascript"><xsl:comment>
						$(document).ready(function()
						{
							initDataTable('<xsl:value-of select="$pageId"/>tab',
							{	"bSort": false,
								
								"fnDrawCallback": function ( oSettings ) {
								if ( oSettings.aiDisplay.length == 0 )
								{
									return;
								}
								
								var nTrs = $('#<xsl:value-of select="$pageId"/>tab tbody tr');
								var iColspan = nTrs[0].getElementsByTagName('td').length;
								var sLastGroup = "";
								for ( var i=0 ; i&lt;nTrs.length ; i++ )
								{
									var iDisplayIndex = oSettings._iDisplayStart + i;
									var sGroup = oSettings.aoData[ oSettings.aiDisplay[iDisplayIndex] ]._aData[0];
									if ( sGroup != sLastGroup )
									{
										var nGroup = document.createElement( 'tr' );
										var nCell = document.createElement( 'td' );
										nCell.colSpan = iColspan;
										nCell.className = "group";
										nCell.innerHTML = sGroup;
										nGroup.appendChild( nCell );
										nTrs[i].parentNode.insertBefore( nGroup, nTrs[i] );
										sLastGroup = sGroup;
									}
								}
								
								initLinksRaw("#<xsl:value-of select="$pageId"/>tab .el-physical", "gMenuPhysical");
							},
							"aoColumnDefs": [
								{ "bVisible": false, "aTargets": [ 0 ] }
							],
							"aaSortingFixed": [[ 0, 'asc' ]],
							"aaSorting": [[ 1, 'asc' ]]
										
							},
							function(t)
							{	t.width("100%");
							}
							);
						});
					</xsl:comment></script>
					<table  id="{$pageId}tab" cellpadding="0" cellspacing="0" border="0" style="width:100%;">
						<thead><tr><th class="ui-state-default">Physical</th><th class="ui-state-default">Space Element</th><th class="ui-state-default">Identifier</th><th class="ui-state-default">Delegation</th></tr></thead>
						<xsl:for-each select="endpoints/endpoint">
							<xsl:variable name="physical" select="."/>
							<xsl:choose>
							<xsl:when test="element">
								<xsl:for-each select="element">
									<xsl:variable name="ename">
										<xsl:call-template name="wrapped">
											<xsl:with-param name="text">
												<xsl:choose>
													<xsl:when test="string-length(name)"><xsl:value-of select="name"/></xsl:when>
													<xsl:otherwise><xsl:value-of select="id"/></xsl:otherwise>
												</xsl:choose>
											</xsl:with-param>
										</xsl:call-template>
									</xsl:variable>
									<tr>
										<xsl:if test="problem">
											<xsl:attribute name="class">error</xsl:attribute>
										</xsl:if>
										<td><div class="el el-physical" entity="{$physical/hash}"><span class="ui-icon-ae ui-icon-ae-physical"><xsl:text> </xsl:text></span><span><xsl:value-of select="$physical/name"/></span></div></td>
										<td entity="{hash}">
										
											<xsl:choose>
												<xsl:when test="type='endpoint'">
													<xsl:attribute name="class">el el-ep</xsl:attribute>
													<span class="ui-icon-ae ui-icon-ae-ep"><xsl:text> </xsl:text></span><span><xsl:copy-of select="$ename"/></span>
												</xsl:when>
												<xsl:when test="type='prototype'">
													<xsl:attribute name="class">el el-proto</xsl:attribute>
													<span class="ui-icon-ae ui-icon-ae-proto"><xsl:text> </xsl:text></span><span><xsl:copy-of select="$ename"/></span>
												</xsl:when>
												<xsl:when test="type='representation'">
													<xsl:attribute name="class">el el-rep</xsl:attribute>
													<span class="ui-icon-ae ui-icon-ae-rep"><xsl:text> </xsl:text></span><span><xsl:copy-of select="$ename"/></span>
												</xsl:when>
												<xsl:otherwise>
													[broken meta]
												</xsl:otherwise>
											</xsl:choose>
															
										</td>
										<td>
											<xsl:call-template name="wrapped">
												<xsl:with-param name="text"><xsl:value-of select="id"/></xsl:with-param>
											</xsl:call-template>
										</td>
										<td>
											<xsl:choose>
												<xsl:when test="local='true'">
												</xsl:when>
												<xsl:otherwise>
													<xsl:attribute name="entity"><xsl:value-of select="delegate-hash"/></xsl:attribute>
													<xsl:attribute name="class">el el-space</xsl:attribute>
													<span class="ui-icon-ae ui-icon-ae-space"><xsl:text> </xsl:text></span><span><xsl:value-of select="delegate-name"/></span>
												</xsl:otherwise>
											</xsl:choose>
										</td>
									</tr>
								</xsl:for-each>
							</xsl:when>
							<xsl:otherwise>
								<tr>
									<td><div entity="{$physical/hash}">
										<xsl:attribute name="class">el el-physical<xsl:if test="problem"> error</xsl:if></xsl:attribute>
										<span class="ui-icon-ae ui-icon-ae-physical"><xsl:text> </xsl:text></span><span><xsl:value-of select="$physical/name"/></span>
									</div></td>
									<td/>
									<td/>
									<td/>
								</tr>
							</xsl:otherwise>
							</xsl:choose>
						</xsl:for-each>
					</table>
					
				</td></tr>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<xsl:template name="space-references">
		<script type="text/javascript"><xsl:comment>
			$(document).ready(function()
			{
				initDataTable('<xsl:value-of select="$pageId"/>tab',
				{	"bSort": false,
					
					"fnDrawCallback": function ( oSettings ) {
					if ( oSettings.aiDisplay.length == 0 )
					{
						return;
					}
					
					var nTrs = $('#<xsl:value-of select="$pageId"/>tab tbody tr');
					var iColspan = nTrs[0].getElementsByTagName('td').length;
					var sLastGroup = "";
					for ( var i=0 ; i&lt;nTrs.length ; i++ )
					{
						var iDisplayIndex = oSettings._iDisplayStart + i;
						var sGroup = oSettings.aoData[ oSettings.aiDisplay[iDisplayIndex] ]._aData[0];
						if ( sGroup != sLastGroup )
						{
							var nGroup = document.createElement( 'tr' );
							var nCell = document.createElement( 'td' );
							nCell.colSpan = iColspan;
							nCell.className = "group";
							nCell.innerHTML = sGroup;
							nGroup.appendChild( nCell );
							nTrs[i].parentNode.insertBefore( nGroup, nTrs[i] );
							sLastGroup = sGroup;
						}
					}
					initLinksRaw(".<xsl:value-of select="$pageId"/> .el-module", "gMenuModule");
				},
				"aoColumnDefs": [
					{ "bVisible": false, "aTargets": [ 0 ] }
				],
				"aaSortingFixed": [[ 0, 'asc' ]],
				"aaSorting": [[ 1, 'asc' ]],
							
				},
				function(t)
				{	t.width("100%");
				}
				);
			});
		</xsl:comment></script>
		<table  id="{$pageId}tab" cellpadding="0" cellspacing="0" border="0" class="display" style="width:100%">
		<thead><tr class="vis-title"><th class="ui-state-default">Module</th><th class="ui-state-default">Endpoint</th><th class="ui-state-default">Space</th></tr></thead>
		<xsl:for-each select="$refs/refs/ref">
			<tr >
				<td><div class="el el-module" entity="{modHash}">
					<span class="ui-icon-ae ui-icon-ae-module"><xsl:text> </xsl:text></span>
					<xsl:value-of select="mod"/>
				</div></td>
				<xsl:choose>
					<xsl:when test="epHash">
						<td class="el el-physical" entity="{epHash}">
							<span class="ui-icon-ae ui-icon-ae-physical"><xsl:text> </xsl:text></span>
							<xsl:value-of select="ep"/>
						</td>
					</xsl:when>
					<xsl:when test="lepHash">
						<td class="el el-physical" entity="{lepHash}">
							<span class="ui-icon-ae ui-icon-ae-ep"><xsl:text> </xsl:text></span>
							<xsl:value-of select="lep"/>
						</td>
					</xsl:when>
				</xsl:choose>
				<td class="el el-space" entity="{spHash}">
					<span class="ui-icon-ae ui-icon-ae-space"><xsl:text> </xsl:text></span>
					<xsl:value-of select="sp"/>
				</td>
			</tr>
		</xsl:for-each>
		</table>				
	</xsl:template>
	
	<xsl:template name="elements">
		<xsl:for-each select="element">
			<tr>
				<xsl:if test="problem">
					<xsl:attribute name="class">error</xsl:attribute>
				</xsl:if>
				<td>
					<xsl:variable name="ename">
						<xsl:call-template name="wrapped">
							<xsl:with-param name="text">
								<xsl:choose>
									<xsl:when test="string-length(name)"><xsl:value-of select="name"/></xsl:when>
									<xsl:otherwise><xsl:value-of select="id"/></xsl:otherwise>
								</xsl:choose>
							</xsl:with-param>
						</xsl:call-template>
					</xsl:variable>
					<xsl:choose>
						<xsl:when test="type='endpoint'">
							<a class="el el-ep" entity="{hash}"><xsl:copy-of select="$ename"/></a>
						</xsl:when>
						<xsl:when test="type='prototype'">
							<a class="el el-proto" entity="{hash}"><xsl:copy-of select="$ename"/></a>
						</xsl:when>
						<xsl:when test="type='representation'">
							<a class="el el-rep" entity="{hash}"><xsl:copy-of select="$ename"/></a>
						</xsl:when>
					</xsl:choose>
				</td>
				<td>
					<xsl:call-template name="wrapped">
						<xsl:with-param name="text"><xsl:value-of select="id"/></xsl:with-param>
					</xsl:call-template>						
				</td>
				<td><xsl:value-of select="type"/></td>
				<td>
					<xsl:choose>
						<xsl:when test="local='true'">
							local
						</xsl:when>
						<xsl:otherwise>
							<a class="el el-space" entity="{delegate-hash}"><xsl:value-of select="delegate-name"/></a>
						</xsl:otherwise>
					</xsl:choose>
				</td>							
			</tr>
		</xsl:for-each>
	</xsl:template>

	<xsl:template name="physical">
		<tr><td class="label">type:</td><td>physical endpoint</td></tr>
		<!--
		<tr><td class="label">space:</td><td>
			<a class="el el-space" entity="{$parentHash}"><xsl:value-of select="$deployed/modules/module//spaces/space[hash=$parentHash]/name"/></a>
		</td></tr>
		-->
		<tr><td class="label">impl:</td>
			<td>
				<xsl:choose>
					<xsl:when  test="$proto">
						<a class="el el-proto" entity="{$proto/proto/hash}"><span class="ui-icon-ae ui-icon-ae-proto"><xsl:text> </xsl:text></span><xsl:value-of select="$proto/proto/name"/></a>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="implementation"/>
					</xsl:otherwise>
				</xsl:choose>
			</td>
		</tr>
		<xsl:if test="$delegateSpace">
			<tr><td class="label">wrapped space:</td>
				<td>
					<a class="el el-space" entity="{$delegateSpace/delegateSpace/hash}"><span class="ui-icon-ae ui-icon-ae-space"><xsl:text> </xsl:text></span><xsl:value-of select="$delegateSpace/delegateSpace/name"/></a>
				</td>
			</tr>
		</xsl:if>
		<tr><td class="label">elements:</td><td>
			<script type="text/javascript"><xsl:comment>
				$(document).ready(function()
				{	initDataTable('<xsl:value-of select="$pageId"/>tab',
					{	"bSort": false,
						"bInfo": false
					} );
				});
			</xsl:comment></script>
			<table id="{$pageId}tab" cellpadding="0" cellspacing="0" border="0" class="display" style="width:100%">
				<thead><tr><th class="ui-state-default">Space Element</th><th class="ui-state-default">Identifier</th><th class="ui-state-default">Delegation</th></tr></thead>
				<xsl:for-each select="elements/element">
					<xsl:variable name="ename">
						<xsl:call-template name="wrapped">
							<xsl:with-param name="text">
								<xsl:choose>
									<xsl:when test="string-length(name)"><xsl:value-of select="name"/></xsl:when>
									<xsl:otherwise><xsl:value-of select="id"/></xsl:otherwise>
								</xsl:choose>
							</xsl:with-param>
						</xsl:call-template>
					</xsl:variable>
					<tr>
						<td entity="{hash}">						
							<xsl:choose>
								<xsl:when test="type='endpoint'">
									<xsl:attribute name="class">el el-ep</xsl:attribute>
									<span class="ui-icon-ae ui-icon-ae-ep"><xsl:text> </xsl:text></span><span><xsl:copy-of select="$ename"/></span>
								</xsl:when>
								<xsl:when test="type='prototype'">
									<xsl:attribute name="class">el el-proto</xsl:attribute>
									<span class="ui-icon-ae ui-icon-ae-proto"><xsl:text> </xsl:text></span><span><xsl:copy-of select="$ename"/></span>
								</xsl:when>
								<xsl:when test="type='representation'">
									<xsl:attribute name="class">el el-rep</xsl:attribute>
									<span class="ui-icon-ae ui-icon-ae-rep"><xsl:text> </xsl:text></span><span><xsl:copy-of select="$ename"/></span>
								</xsl:when>
							</xsl:choose>
											
						</td>
						<td>
							<xsl:call-template name="wrapped">
								<xsl:with-param name="text"><xsl:value-of select="id"/></xsl:with-param>
							</xsl:call-template>
						</td>
						<td>
							<xsl:choose>
								<xsl:when test="local='true'">
								</xsl:when>
								<xsl:otherwise>
									<xsl:attribute name="entity"><xsl:value-of select="delegate-hash"/></xsl:attribute>
									<xsl:attribute name="class">el el-space</xsl:attribute>
									<span class="ui-icon-ae ui-icon-ae-space"><xsl:text> </xsl:text></span><span><xsl:value-of select="delegate-name"/></span>
								</xsl:otherwise>
							</xsl:choose>
						</td>
					</tr>
				</xsl:for-each>			
			</table>
		</td></tr>
		<xsl:call-template name="state"/>
	</xsl:template>
			
	<xsl:template name="endpoint">
		
		<xsl:choose>
			<xsl:when test="$hrd">
				<tr><td class="label"></td><td class="hrd book-text"><xsl:copy-of select="$hrd"/></td></tr>
				<xsl:if test="fields/field">
					<xsl:call-template name="state"/>
				</xsl:if>
			</xsl:when>
			<xsl:otherwise>
			
				<tr><td class="label">type:</td><td>logical endpoint</td></tr>
				<tr><td class="label">identifier:</td><td><xsl:value-of select="identifier"/></td></tr>
				<tr><td class="label">space:</td><td>
					<a class="el el-space" entity="{$parentHash}"><xsl:value-of select="$deployed/modules/module//spaces/space[hash=$parentHash]/name"/></a>
				</td></tr>
				<tr><td class="label">verbs:</td><td>
					<xsl:choose>
						<xsl:when test="interface/verbs/verb">
							<xsl:for-each select="interface/verbs/verb">
								<xsl:value-of select="."/>
								<xsl:if test="position() != last()">, </xsl:if>
							</xsl:for-each>
						</xsl:when>
						<xsl:otherwise>[none]</xsl:otherwise>
					</xsl:choose>
				</td></tr>
				<tr><td class="label">grammar:</td><td>
					<!--<xsl:value-of select="interface/grammar"/>-->
					<xsl:for-each select="interface/grammar">
						<xsl:call-template name="top2"/>			
					</xsl:for-each>
				</td></tr>
				<tr><td class="label">arguments:</td><td>
					<xsl:choose>
						<xsl:when test="interface/args/arg">
							<table>
							<tr class="table-header"><td>Name</td><td>isIdentifier?</td><td>Representation</td><td>Default</td></tr>
								<xsl:for-each select="interface/args/arg">
								<tr>
									<td><xsl:value-of select="name"/></td>
									<td><xsl:value-of select="isId"/></td>
									<td>
										<xsl:for-each select="reps/rep">
											<xsl:choose>
												<xsl:when test="hash">
													<a href="{$base}{hash}"><xsl:value-of select="name"/></a>
												</xsl:when>
												<xsl:otherwise><xsl:value-of select="class"/></xsl:otherwise>
											</xsl:choose>
											<xsl:if test="position() != last()">, </xsl:if>
										</xsl:for-each>								
									</td>
									<td><xsl:value-of select="default"/></td>
								</tr>
							</xsl:for-each>
							</table>					
						</xsl:when>
						<xsl:otherwise>[none]</xsl:otherwise>
					</xsl:choose>
				</td></tr>
				<tr><td class="label">returns:</td><td>
					<xsl:choose>
						<xsl:when test="interface/reps/rep">
							<xsl:for-each select="interface/reps/rep">
								<!--<xsl:message><xsl:value-of select="hash"/></xsl:message>-->
								<xsl:choose>
									<xsl:when test="hash">
										<a href="{$base}{hash}"><xsl:value-of select="name"/></a>
									</xsl:when>
									<xsl:otherwise><xsl:value-of select="class"/></xsl:otherwise>
								</xsl:choose>
								
								<xsl:if test="position() != last()">, </xsl:if>
							</xsl:for-each>								
						</xsl:when>
						<xsl:otherwise>[none]</xsl:otherwise>
					</xsl:choose>
				</td></tr>
				<tr><td class="label">exceptions:</td><td>
					<xsl:choose>
						<xsl:when test="interface/exs/ex">
							<table>
							<tr class="table-header"><td>Id</td><td>Description</td></tr>
							<xsl:for-each select="interface/exs/ex">
								<tr>
									<td><xsl:value-of select="name"/></td>
									<td><xsl:value-of select="desc"/></td>
								</tr>
							</xsl:for-each>
							</table>
						</xsl:when>
						<xsl:otherwise>[none]</xsl:otherwise>
					</xsl:choose>
				</td></tr>
				<xsl:call-template name="state"/>
			
			</xsl:otherwise>
		</xsl:choose>
		
		
		
		
			
	</xsl:template>
			
	<xsl:template name="prototype">
	
		<xsl:choose>
			<xsl:when test="$hrd">
				<tr><td class="label"></td><td class="hrd book-text"><xsl:copy-of select="$hrd"/></td></tr>
			</xsl:when>
			<xsl:otherwise>
	
				<tr><td class="label">type:</td><td>prototype</td></tr>
				<tr><td class="label">identifier:</td><td><xsl:value-of select="identifier"/></td></tr>
				
				<xsl:choose>
					<xsl:when test="$refs">
						<tr><td class="label">references:</td><td>
							<xsl:call-template name="space-references"/>
						</td></tr>
					</xsl:when>
					<xsl:otherwise>	
						<tr><td class="label">class:</td><td><xsl:value-of select="implementation"/></td></tr>
						<tr><td class="label">parameters:</td><td>
							<table>
								<tr class="table-header"><td>Name</td><td>Description</td><td>Class</td><td>Default</td></tr>
							<xsl:for-each select="parameters/parameter">
								<tr>
									<td><xsl:value-of select="name"/></td>
									<td><xsl:value-of select="desc"/></td>
									<td><xsl:value-of select="class"/></td>
									<td><xsl:value-of select="default"/></td>
								</tr>
							</xsl:for-each>			
							</table>
						</td></tr>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<xsl:template name="representation">
		<xsl:choose>
			<xsl:when test="$hrd">
				<tr><td class="label"></td><td class="hrd book-text"><xsl:copy-of select="$hrd"/></td></tr>
			</xsl:when>
			<xsl:otherwise>
				<tr><td class="label">type:</td><td>representation</td></tr>
				<tr><td class="label">implementation:</td><td><xsl:value-of select="implementation"/></td></tr>
				
				<xsl:choose>
					<xsl:when test="$refs">
						<tr><td class="label">references:</td><td>
							<xsl:call-template name="space-references"/>
						</td></tr>
					</xsl:when>
					<xsl:otherwise>	
						<tr><td class="label">interface:</td><td>
							<div class="error">JavaDoc not found for this representation. <a href="/tools/javadoc/">Generate</a></div>
							<xsl:for-each select="methods/method">
								<div>
									<xsl:value-of select="return"/>&#160;<xsl:value-of select="name"/>
									(
									<xsl:for-each select="params/param"><xsl:value-of select="."/>
										<xsl:if test="position() != last()">, </xsl:if>
									</xsl:for-each>
									)
									<xsl:if test="exceptions/exception">throws
										<xsl:for-each select="exceptions/exception">
											<xsl:value-of select="."/>
											<xsl:if test="position() != last()">, </xsl:if>
										</xsl:for-each></xsl:if>;
								</div>
							</xsl:for-each>
							</td></tr>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:otherwise>
			</xsl:choose>
	</xsl:template>
	
	<xsl:template name="wrapped">
		<xsl:param name="text"/>
		<xsl:choose>
			<xsl:when test="string-length($text)>30">
				<xsl:value-of select="substring($text,1,30)"/><wbr/><xsl:call-template name="wrapped">
					<xsl:with-param name="text" select="substring($text,30+1)"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$text"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<xsl:template name="state">
		<tr><td class="label">state:</td>
		<td>
			<xsl:choose>
				<xsl:when test="$statePlugin">
					<xsl:copy-of select="$statePlugin"/>
				</xsl:when>
				<xsl:when test="fields/field">
					<table class="data-table">
						<tr class="vis-title"><td>Name</td><td>Value</td></tr>
						<xsl:for-each select="fields/field">
							<tr>
								<xsl:if test="@name='problem'">
									<xsl:attribute name="class">error</xsl:attribute>
								</xsl:if>
								<td><xsl:value-of select="@name"/></td>
								<td>
									<xsl:choose>
										<xsl:when test="*">
											<xsl:call-template name="top2"/>
										</xsl:when>
										<xsl:otherwise>
											<pre style="margin: 0px;"><xsl:value-of select="."/></pre>
										</xsl:otherwise>
									</xsl:choose>
								</td>
							</tr>
						</xsl:for-each>
					</table>
				</xsl:when>
				<xsl:otherwise>[none]</xsl:otherwise>
			</xsl:choose>				
		</td></tr>
	</xsl:template>
	
</xsl:stylesheet>