
function loadTab(url)
{	$.get(url, tabLoaded,"string");
}
function tabLoaded(data)
{
	tabId=uniqueId("tab");	
	div=$(document.createElement("div"));
	div.attr("id",tabId);
	$("#dyn").append(div);
	div.html(data);
	d=$("div", div);
	title=d.attr("tabtitle");
	if (title==null || title.length==0) title="[unknown]";
	$("#tabs2").tabs("add","#"+tabId,title);
	$('html, body').scrollTop(0);
}

// generate unique id
uniqueId = function(prefix)
{	return prefix + uniqueId.mCount++;
}
uniqueId.mCount=0;

function doMenu(menuId,entityId)
{
	url="/tools/ae/view/"+menuId;
	if (entityId!=null)
	{	url+="/"+entityId;
	}
	location.href= url;
}


//***************
//allModules stuff
//***************
function initDataTable(tableId, props, func)
{	
	hid="#"+tableId;
	table=$(hid);
	//console.log("initDataTable "+tableId+" "+table);
	//console.log(table);
	a = {'bJQueryUI': true,'sPaginationType': 'full_numbers', 'aLengthMenu': [[10, 25, 50, -1], [10, 25, 50, "All"]], 'iDisplayLength': -1, 'oLanguage': { 'sSearch': "Filter:"} };
	if (props!=null)
	{	jQuery.extend(a, props);
	}
		
	table.dataTable( a );
	//$(hid+" tr").contextMenu(menuId, { click: function(target,item) { doMenu(item.id,$(target).attr('hash')); } });
	rows=$(hid+" tr");
	rows.mouseenter( function() { $(this).addClass('row_selected'); } );
	rows.mouseleave( function() { $(this).removeClass('row_selected'); } );
		
	if (func!=null)
	{	func(table);
	}
		
}

function initLinks(ready,selector,menuId)
{	//console.log("initLinks "+ready+" "+selector+" "+menuId);
	$(ready).ready(function()
	{	initLinksRaw(selector,menuId);
	});
}

function initLinksRaw(selector,menuId)
{	
	direct=$('#'+menuId+' li').size()==1;
	if (direct)
	{	
		$(selector).click(function(e)
		{	defAction= $('#'+menuId+' li').attr('id');
			doMenu(defAction,$(this).attr('entity'));
		}); 		
	}
	else
	{	
		$(selector).each(function(index,item)
		{	
			$(item).contextMenu(menuId,
			{	click: function(target,item) { doMenu(item.id,$(target).attr('entity')); },
				onShowMenu: function(e,m) { $(item).addClass('row_selected_menu'); return m; },
				onHideMenu: function() { $(item).removeClass('row_selected_menu'); },
				shadow: true
			});
		});
	}
}


//***************
//physical structure stuff
//***************
function doSmaller(svgId)
{	e=$("#"+svgId);
	scale=e.attr("scale");
	scale*=0.66;
	e.attr("scale",scale);
	doSVGUpdate(svgId);
}
function doLarger(svgId)
{	e=$("#"+svgId);
	scale=e.attr("scale");
	scale/=0.66;
	e.attr("scale",scale);
	doSVGUpdate(svgId);
}
function doSVGUpdate(svgId)
{	
	url=generateSVGURL(svgId);
	e=$("#"+svgId);
	e.svg('destroy');
	e.svg(
	{	loadURL: url,
		changeSize: true,
		onLoad: function()
		{	//console.log('svgready');
			initLinksRaw('.cmSpace', 'gMenuSpace');
			initLinksRaw('.cmModule', 'gMenuModule');
			initLinksRaw('.cmPhysical', 'gMenuPhysical');
		}
	});
}

function generateSVGURL(svgId)
{
	e=$("#"+svgId);
	mod=$("#"+svgId+"module").val();
	lib=$("#"+svgId+"lib").val();
	depth=$("#"+svgId+"depth").val();
	//shading=$("#"+svgId+"shading").attr("checked");
	shading=$("#"+svgId+"shading").val();
	url=e.attr("url")+"&scale="+e.attr("scale")+"&module="+mod+"&lib="+lib+"&depth="+depth+"&shading="+shading;
	return url;
}

function downloadSVG(svgId)
{	url=generateSVGURL(svgId);
	window.open(url+"&download");
}
